package jp.gr.java_conf.skrb.game.pong.fullscreen;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;

import java.awt.GraphicsEnvironment;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.DisplayMode;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferStrategy;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import jp.gr.java_conf.skrb.game.pong.InputEvent;
import jp.gr.java_conf.skrb.game.pong.InputListener;
import jp.gr.java_conf.skrb.game.pong.Sprite;
import jp.gr.java_conf.skrb.game.pong.awt.AWTPongView;

public class FSPongView extends AWTPongView {
    private GraphicsDevice device;
    private DisplayMode orgMode;
    
    public FSPongView() {
	super();
	
	frame.setUndecorated(true);
    }

    public void init() {
	GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        device = ge.getDefaultScreenDevice();
        GraphicsConfiguration gc = device.getDefaultConfiguration();
             
        orgMode = device.getDisplayMode();
        DisplayMode mode = new DisplayMode(640, 480, 32, DisplayMode.REFRESH_RATE_UNKNOWN);

	device.setFullScreenWindow(frame);
	device.setDisplayMode(mode);

	frame.createBufferStrategy(2);
	strategy = frame.getBufferStrategy();
    }

    public void end() {
//	device.setDisplayMode(orgMode);
	device.setFullScreenWindow(null);
    }

    public void draw(int rest, int score, int highScore, Sprite ball, Sprite pad) {
	Graphics g = strategy.getDrawGraphics();
	((java.awt.Graphics2D)g).translate(160, 20);

	if (!strategy.contentsLost()) {
	    clear(g);
	    drawInfo(g, rest, score, highScore);
	    
	    drawSprites(g, ball, pad);
	    
	    try {
		strategy.show();
	    } catch (IllegalStateException ex) {}
	    g.dispose();
	}
    }

    public void draw(int score, int highScore, Sprite ball, Sprite pad) {
	Graphics g = strategy.getDrawGraphics();
	((java.awt.Graphics2D)g).translate(160, 20);

	if (!strategy.contentsLost()) {
	    clear(g);
	    drawInfo(g, score, highScore);
	    
	    drawSprites(g, ball, pad);
	    
	    drawStartMessage(g);

	    try {
		strategy.show();
	    } catch (IllegalStateException ex) {}
	    g.dispose();
	}
    }
}
